package com.hnshituo.core.orm.plugins;


 
import java.text.DateFormat;
import java.util.Date;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;

import org.apache.ibatis.executor.Executor;
import org.apache.ibatis.mapping.BoundSql;
import org.apache.ibatis.mapping.MappedStatement;
import org.apache.ibatis.mapping.ParameterMapping;
import org.apache.ibatis.plugin.Interceptor;
import org.apache.ibatis.plugin.Intercepts;
import org.apache.ibatis.plugin.Invocation;
import org.apache.ibatis.plugin.Plugin;
import org.apache.ibatis.plugin.Signature;
import org.apache.ibatis.reflection.MetaObject;
import org.apache.ibatis.session.Configuration;
import org.apache.ibatis.session.ResultHandler;
import org.apache.ibatis.session.RowBounds;
import org.apache.ibatis.type.TypeHandlerRegistry;
import org.apache.log4j.Logger;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import com.hnshituo.core.auth.service.HomeService;
 
@Intercepts({
        @Signature(type = Executor.class, method = "query", args = { MappedStatement.class, Object.class,
                RowBounds.class, ResultHandler.class }) })
public class MybatisInterceptor implements Interceptor {
	private static Logger logger = Logger.getLogger(MybatisInterceptor.class);
    private Properties properties;
    
    @Override
	public Object intercept(Invocation invocation) throws Throwable {
        MappedStatement mappedStatement = (MappedStatement) invocation.getArgs()[0];
        Object parameter = null;
        if (invocation.getArgs().length > 1) {
            parameter = invocation.getArgs()[1];
        }
        
        String sqlId = mappedStatement.getId();
        String dataPrgCondition = null;
        
        if (parameter != null && Map.class.isAssignableFrom(parameter.getClass())) {
        	HttpServletRequest request = getRequest();
            String[] dataPrgs = (String[]) request.getAttribute(HomeService.REQUEST_DATA_PRG);
            String fieldName = (String) request.getAttribute(HomeService.REQUEST_DATA_FIELD);
            
            if (fieldName != null) {
            	dataPrgCondition = getDataPrgCondition(fieldName, dataPrgs);
            }
            ((Map)parameter).put("_dataPrg", dataPrgCondition);
        }
        
        BoundSql boundSql = mappedStatement.getBoundSql(parameter);
        Configuration configuration = mappedStatement.getConfiguration();
        Object returnValue = null;
        long start = System.currentTimeMillis();
        
        returnValue = invocation.proceed();
        long end = System.currentTimeMillis();
        long time = (end - start);
        if (time > 1000) {
        	String sql = getSql(configuration, boundSql, sqlId, time);
            logger.warn("SQL执行时长：" + time + ", SQL：" + sql);
        }
        return returnValue;
    }
    
    protected String getDataPrgCondition(String field, String[] dataPrgs) {
    	String result = null;
		StringBuilder deptIdCondition = null;
		if (field != null && dataPrgs != null) {
			deptIdCondition = new StringBuilder();
			for (int i = 0; i < dataPrgs.length; i++) {
				String deptId = dataPrgs[i];
				if (i==0) {
					deptIdCondition.append(" " + field + " LIKE '" + deptId + "%' ");
				} else {
					deptIdCondition.append(" OR " + field + " LIKE '" + deptId + "%'");
				}
			}
			
			if (deptIdCondition.length() > 0) {
				deptIdCondition.insert(0, " (").append(") ");
			} else {
				deptIdCondition.append(" " + field + " is null ");
			}
			result = deptIdCondition.toString();
		}		
		return result;
	}
    
    public HttpServletRequest getRequest() {
		 return ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();
	}
 
    public static String getSql(Configuration configuration, BoundSql boundSql, String sqlId, long time) {
        String sql = showSql(configuration, boundSql);
        StringBuilder str = new StringBuilder(100);
        str.append(sqlId);
        str.append(":");
        str.append(sql);
        str.append(":");
        str.append(time);
        str.append("ms");
        return str.toString();
    }
 
    private static String getParameterValue(Object obj) {
        String value = null;
        if (obj instanceof String) {
            value = "'" + obj.toString() + "'";
        } else if (obj instanceof Date) {
            DateFormat formatter = DateFormat.getDateTimeInstance(DateFormat.DEFAULT, DateFormat.DEFAULT, Locale.CHINA);
            value = "'" + formatter.format(new Date()) + "'";
        } else {
            if (obj != null) {
                value = obj.toString();
            } else {
                value = "";
            }
 
        }
        return value;
    }
 
    public static String showSql(Configuration configuration, BoundSql boundSql) {
        Object parameterObject = boundSql.getParameterObject();
        List<ParameterMapping> parameterMappings = boundSql.getParameterMappings();
        String sql = boundSql.getSql().replaceAll("[\\s]+", " ");
        if (parameterMappings.size() > 0 && parameterObject != null) {
            TypeHandlerRegistry typeHandlerRegistry = configuration.getTypeHandlerRegistry();
            if (typeHandlerRegistry.hasTypeHandler(parameterObject.getClass())) {
                sql = sql.replaceFirst("\\?", getParameterValue(parameterObject));
 
            } else {
                MetaObject metaObject = configuration.newMetaObject(parameterObject);
                for (ParameterMapping parameterMapping : parameterMappings) {
                    String propertyName = parameterMapping.getProperty();
                    if (metaObject.hasGetter(propertyName)) {
                        Object obj = metaObject.getValue(propertyName);
                        sql = sql.replaceFirst("\\?", getParameterValue(obj));
                    } else if (boundSql.hasAdditionalParameter(propertyName)) {
                        Object obj = boundSql.getAdditionalParameter(propertyName);
                        sql = sql.replaceFirst("\\?", getParameterValue(obj));
                    }
                }
            }
        }
        return sql;
    }
 
    @Override
	public Object plugin(Object target) {
        return Plugin.wrap(target, this);
    }
 
    @Override
	public void setProperties(Properties properties) {
    	 String prop1 = properties.getProperty("prop1");
         String prop2 = properties.getProperty("prop2");
         System.out.println(prop1 + "------" + prop2);
        this.properties = properties;
    }
}
